{# _datamax/api/templates/api_exchange/all.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">All APIs in the system</h5>
</a>
<br/>

<table id="Content" class="display" style="width:100%">
<thead>
    <tr>
        <td>Name</td>
        <td>Version</td>
        <td>Description</td>
        <td>Query</td>
        <td>Connection</td>
        <td>Category</td>
        <td>Status</td>
        <td>Created on</td>
        <td>Action</td>
    </tr>
</thead>
</table>

<script>
    $(document).ready(function() {
        $('#Content').DataTable({
             "stateSave": true,
             "ordering": false,
             "ajax": {
                url: "{{ url_for('api_exchange.index') }}" + "?name=all_api",
                dataSrc: 'Contents'
             },
             "columns": [
                { data: "name", "width": "10%" },
                { data: "version", "width": "5%" },
                { data: "description", "width": "15%" },
                { data: "query", "width": "30%"},
                { data: "connection_name"},
                { data: "category"},
                { data: "status", "width": "7%"},
                { data: "created_on" },
                { "data": null, "width": "10%" }
             ],
             columnDefs: [{
                // puts a button in the last column
                targets: [-1], render: function (a, b, data, d) {
                    if (data.status == 'pending') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('api_exchange.index') }}?name=approve_api&id=' + data.id + '&api_name=' + data.name + '" class="approve-api">' +
                               '<i class="fas fa-check-square"></i></a>&ensp;&ensp;' +
                               '<a href="{{ url_for('api_exchange.index') }}?name=reject_api&id=' + data.id + '" class="reject-api">' +
                               '<i class="fas fa-times-circle"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    } else if (data.status == 'published') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('api_exchange.index') }}?name=reject_api&id=' + data.id + '" class="reject-api">' +
                               '<i class="fas fa-times-circle"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    }else if (data.status == 'rejected') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    }
                    return "";
                }
            }]
      });

      $("#Content").on('click', '.approve-api, .reject-api', function(){
            console.log("requesting .... " + $(this).attr('href'));
            $.ajax({
                 type: "GET",
                 url: $(this).attr('href'),
                 success: function(data) {
                        console.log(data);
                        window.location.href = "./all";
                 },
                 fail: function(data) {
                        console.log(data);
                 }
           });
           return false;
      });
} );
</script>
{% endblock %}